#! /bin/bash
usage ()
{
    echo "cxc_patch.sh [-s | -b] -f <file of patches"
    echo "             -r <path of distrbutrion>"
    echo "             -v <path of patchs>"
    echo "Where"
    echo "  -s - Only install Source code."
    echo "  -b - Install Source code and new binaries."
    echo "       (Default is to install binaries only)"
#    echo "  -nh - Do not hide uninstall files
    echo "  -f <file of patches> Files list supplied with"
    echo "       this distribution. Default: $ListFiles"
    echo "  -r <path of distriburtion> Directory to install"
    echo "       patches to. Default is $RootTree"
    echo "  -v <path of patches> Directory where patches were"
    echo "       untarred to. Default is $FromTree"
    echo "  -u <oldVersion> Uninstall current version to"
    echo "      oldversion."
#    echo "  -p build patch package"
#    echo "  -cp "Copy instead of move files"
    echo
}
init ()
{
    Error=0
    SoftwareOnly=0
    Binary=1
    Source=0
    ListFile=CIAO_4.6.1
    TOP="`pwd`"
    RootTree="$TOP"
    FromTree=$TOP"/"$ListFile"_tmp"
    OldVersion=""
    SetFlag=0
    dot="."
    Uninstall=0
    newversion=""
    CP="mv"
    backout=""
    dbg="# "
    ech=""
    cleanup=0
    package=""
    if [ "`uname`" != "Darwin" ] ; then
	SO="so"
    else
	SO="dylib"
    fi
}
move_file ()
{
#    echo "Movefile $1 $2 $3"
    if [ "$1" != "rm" ]
    then
        if [ -f $2 ]
        then
#	    echo found file $2
	    mkdir -p `dirname $3`
            if [ -f $3 ]
            then
#	        echo delete  file $3
                $ech rm -f $3
            fi
#	    echo  $1 $2 $3
	    $ech $1 $2 $3

	else
	    if [ -d $2 ]
	    then
#		echo found directory $2
		if [ -d $3 ]
                then
#		    echo not deleting directory $3
		    $ech rm -rf $3
		fi
		if [ "$1" != "cp" ]
		then
#		    echo $1 $2 $3
		    $ech $1 $2 $3
		else
		    mkdir -p `dirname $3`
#		    echo cp recursive $2 $3
		    $ech cp -r $2 $3
		fi
	    fi
        fi
    else
	echo remove $2
        $ech rm -f $2
    fi
}

init
while [ "$#" -ne 0 ]
do
    case "$1"
    in
	-nh )
	    dot=""
	    ;;
        -cp )
	    CP="cp"
	    ;;
	-p )
	    CP="cp"
	    if [ $SetFlag -ne 0 ]
	    then
		Error=10
	    fi
	    SetFlag=1
	    SourceOnly=0
	    Binary=1
	    Source=1
	    package="y"
            ;;
	-debug )
	    dbg=""
	    ech="echo"
	    ;;
        -s )
	    if [ $SetFlag -ne 0 ]
	    then
		Error=10
	    fi
	    SetFlag=1
	    SoftwareOnly=1
	    Binary=0
	    Source=1
        ;;
	-b )
	    if [ $SetFlag -ne 0 ]
	    then
		Error=10
	    fi
	    SetFlag=1
	    SourceOnly=0
	    Binary=1
	    Source=1
	;;
	-f )
	    if [ "$2" != "" ]
	    then
		ListFile="$2"
		shift
	    else
	        Error=1
	    fi
        ;;
	-r )
	    if [ "$2" != "" ]
	    then
		RootTree="$2"
		shift
	    else
		Error=2
	    fi
        ;;
	-v )
	    if [ "$2" != "" ]
	    then
		FromTree="$2"
		shift
	    else
		Error=3
	    fi
        ;;
	-u )
	    if [ "$2" != "" ]
	    then
		Uninstall=1
		newversion="_${2}"
		FromTree="${RootTree}"
		CP="mv"
		backout="${dot}"
		shift
	    else
		Error=4
	    fi
        ;;
	* )
	    Error=1000
	;;
    esac
    shift
done

# read old internal VERSION file

if [ ! -f "${RootTree}/internal_VERSION" ] ; then
    \cp "${RootTree}/VERSION" "${RootTree}/internal_VERSION" 
fi

version_file="${RootTree}/internal_VERSION"
read softname softnum dummy1 < ${version_file}

oldversion=${softname}"_"${softnum}

if [ ${Uninstall} -eq 0 ]
then
    installtest="!="
else
    installtest="="
fi

if [ $Error -eq 0 ]
then
  if [ $oldversion $installtest $ListFile ]
  then

#update internal VERSION file

    move_file "mv" "${version_file}" "${RootTree}/${dot}internal_VERSION_${oldversion}"
    move_file "${CP}" "${FromTree}/${backout}internal_VERSION${newversion}" "${version_file}"

    cat ${ListFile} |
    while read srcdir bindir srcname binname dummy1
    do
#	atest=`echo $binname | grep '\.a$'`
	atest=""
	if [ $Binary -eq 1 ]
	then
	    if [ "$atest" = "" ]
	    then
		if [ "${binname}" != "-" ]
		then

# Don't backup files in the doc/xml directory
# This causes ahelp to generate duplicate entries

		  if [ $bindir != "doc/xml" ]
		  then
		    move_file "mv" $RootTree"/"$bindir"/"$binname $RootTree"/"$bindir"/"$dot$binname"_"$oldversion
		  fi
		    move_file "${CP}" $FromTree"/"$bindir"/"${backout}${binname}${newversion} $RootTree"/"$bindir"/"$binname
		fi
	    fi
	fi

	if [ $Source -eq 1 ]
	then
	    if [ "${srcname}" != "-" ]
	    then
		move_file "mv" $RootTree"/"$srcdir"/"$srcname $RootTree"/"$srcdir"/"$dot$srcname"_"$oldversion
		move_file "${CP}" $FromTree"/"$srcdir"/"$backout$srcname$newversion $RootTree"/"$srcdir"/"$srcname
	    fi
	fi

	if [ $SoftwareOnly -eq 1 ]
	then
	    if [ $binname != "-" ]
	    then

# Don't backup files in the doc/xml directory
# This causes ahelp to generate duplicate entries

	      if [ $bindir != "doc/xml" ]
	      then
		move_file "mv" $RootTree"/"$bindir"/"$binname $RootTree"/"$bindir"/"$dot$binname"_"$oldversion
	      fi
	    fi
	fi

    done
  else
      if [ "$installtest" = "=" ]
      then
	  echo "Error - Version mismatch - Can't Uninstall"
      else
	  echo "Error - Update was done. Versions match"
      fi
  fi
else
    usage  
fi
